import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class Block here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Block extends Actor
{
    public boolean isBomb=false;
    public boolean isFlagged=false;
    public boolean isOpen=false;
    
    /**
     * Act - do whatever the Block wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        MouseInfo mouse = Greenfoot.getMouseInfo();
        
        if (Greenfoot.mouseClicked(this)) {
            if (mouse.getButton()==3 && !isOpen) {
                if (isFlagged) {
                    setImage("Block.png");
                    isFlagged=false;
                } else {
                    setImage("BlockFlagged.png");              
                    isFlagged=true;
                }
                return;
            }
            if (isBomb) {
                setImage("Bomb.png");
                Greenfoot.playSound("bomb.wav");
                Greenfoot.stop();
            } else {               
                openBlock(this);
            }  
        }
    }
    
    public int getBombNumber(Block block) {
                List<Block> blocks = block.getNeighbours(1, true, Block.class);
                int bombNumber=0;
                for (Block Nblock : blocks) {
                    if (Nblock.isBomb) {
                        bombNumber++;
                    }                       
                }               
                return bombNumber;
    }
    
    public void openBlock(Block block) {
        block.isOpen=true;
        block.setImage("BlockClicked["+block.getBombNumber(block)+"].png");                
        if (getBombNumber(block)==0) {
            List<Block> blocks = block.getNeighbours(1, true, Block.class);
            for (Block Nblock : blocks) {
                if (!Nblock.isOpen && Nblock.getBombNumber(Nblock)==0) {
                    openBlock(Nblock);
                } else {
                    Nblock.setImage("BlockClicked["+Nblock.getBombNumber(Nblock)+"].png");                                    
                    Nblock.isOpen=true;
                }
            }
        }
    }
}
