import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;
import java.util.Collections;
/**
 * Write a description of class Pavlion here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Pavlion extends World
{
    private ArrayList<Block> blocks = new ArrayList<Block>();   
    private int bombNumber = 20;
    
    /**
     * Constructor for objects of class Pavlion.
     * 
     */
    public Pavlion()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(32, 22, 25); 
        for (int i=1; i<31; i++) {
            for (int j=1; j<21; j++) {
                Block block = new Block();
                blocks.add(block);
                addObject(block, i, j);
            }
        }
        Collections.shuffle(blocks);
        for (int i=0; i<bombNumber; i++) {
            blocks.get(i).isBomb = true;
        }
    }
    
    public void act() {
        for (Block block: blocks) {
            if (block.isBomb) {
                if (!block.isFlagged) {
                    return;
                }
            } else {
                if (!block.isOpen) {
                    return;
                }
            }
        }
        Greenfoot.playSound("win.wav");
        Greenfoot.stop();
    }
}
